#pragma once

#include "WaylandPointerInterface.h"

#include "wayland-client.h"

#include <memory>

class WaylandSeatInterface
{
public:
    WaylandSeatInterface(wl_seat* seat);

private:

    static void seatCapabilitiesEvent(void *data, struct wl_seat *wl_seat, uint32_t capabilities);

    static void seatNameEvent(void *data, struct wl_seat *wl_seat, const char *name);

    void onSeatCapabilitiesEvent(uint32_t capabilities);

    void setKeyboard(wl_keyboard* keyboard);

    void setPointer(wl_pointer* pointer);

    wl_seat* mSeat{nullptr};
    wl_seat_listener mSeatListener;

    wl_keyboard* mKeyboard{nullptr};

    std::unique_ptr<WaylandPointerInterface> mPointerInterface;
};
